GTGBasic.h File Reference

GTGBasic is a basic interface to generate trace in various formats. More...

`#include <stdlib.h>`
`#include <string.h>`
`#include "GTGColor.h"`
`#include "GTGTypes.h"`

Go to the source code of this file.

## Macros

#define | GTG_FLAG_NONE 0
| No flag specified.
#define | GTG_FLAG_USE_MPI 1
| Several MPI processes are currently using GTG.
#define | GTG_FLAG_NOTBUF 2
| For writing the traces in a non-buffered mode.
#define | GTG_FLAG_OUTOFORDER 4
| Allow the application to record events out of order.
#define | GTG_FLAG_PAJE_MULTIPLE_FILES 8
| For writing events in separate files (one file per container)

## Typedefs

typedef uint8_t | gtg_flag_t
| Flags that can be specified to GTG.
typedef enum traceType | traceType_t

## Enumerations

enum | traceType { PAJE , VITE , OTF , TAU }

## Functions

void | setTraceType (traceType_t type)
traceType_t | getTraceType ()
char * | getName (int procRk)
int | bufferedModeActivated ()
trace_return_t | initTrace (const char *filename, int rank, gtg_flag_t flags)
trace_return_t | endTrace ()
trace_return_t | setCompress (int val)
trace_return_t | addContType (const char *alias, const char *contType, const char *name)
trace_return_t | addStateType (const char *alias, const char *contType, const char *name)
trace_return_t | addEventType (const char *alias, const char *contType, const char *name)
trace_return_t | addLinkType (const char *alias, const char *name, const char *contType, const char *srcContType, const char *destContType)
trace_return_t | addVarType (const char *alias, const char *name, const char *contType)
trace_return_t | addEntityValue (const char *alias, const char *entType, const char *name, gtg_color_t p_color)
trace_return_t | addContainer (varPrec time, const char *alias, const char *type, const char *container, const char *name, const char *file)
trace_return_t | destroyContainer (varPrec time, const char *name, const char *type)
trace_return_t | setState (varPrec time, const char *type, const char *cont, const char *val)
trace_return_t | pushState (varPrec time, const char *type, const char *cont, const char *val)
trace_return_t | popState (varPrec time, const char *type, const char *cont)
trace_return_t | addEvent (varPrec time, const char *type, const char *cont, const char *val)
trace_return_t | startLink (varPrec time, const char *type, const char *cont, const char *src, const char *dest, const char *val, const char *key)
trace_return_t | endLink (varPrec time, const char *type, const char *cont, const char *src, const char *dest, const char *val, const char *key)
trace_return_t | setVar (varPrec time, const char *type, const char *cont, varPrec val)
trace_return_t | addVar (varPrec time, const char *type, const char *cont, varPrec val)
trace_return_t | subVar (varPrec time, const char *type, const char *cont, varPrec val)
trace_return_t | AddComment (const char *comment)

## Detailed Description

GTGBasic is a basic interface to generate trace in various formats.

Version
  0.1

Authors
  Developers are :
  Francois Rue - franc.nosp@m.ois..nosp@m.rue@l.nosp@m.abri.nosp@m..fr
  Francois Trahay - franc.nosp@m.ois..nosp@m.traha.nosp@m.y@la.nosp@m.bri.f.nosp@m.r
  Johnny Jazeix - jazei.nosp@m.x@en.nosp@m.seirb.nosp@m.-mat.nosp@m.meca..nosp@m.fr
  Kevin Coulomb - kevin.nosp@m..cou.nosp@m.lomb@.nosp@m.gmai.nosp@m.l.com
  Mathieu Faverge - faver.nosp@m.ge@l.nosp@m.abri..nosp@m.fr
  Olivier Lagrasse - lagra.nosp@m.sse@.nosp@m.ensei.nosp@m.rb-m.nosp@m.atmec.nosp@m.a.fr
  It has been initiated in 2010 by eztrace and ViTE projects that both needs a good library to generate traces.

## Macro Definition Documentation

## GTG_FLAG_NONE

#define GTG_FLAG_NONE 0

No flag specified.

## GTG_FLAG_NOTBUF

#define GTG_FLAG_NOTBUF 2

For writing the traces in a non-buffered mode.

## GTG_FLAG_OUTOFORDER

#define GTG_FLAG_OUTOFORDER 4

Allow the application to record events out of order.

## GTG_FLAG_PAJE_MULTIPLE_FILES

#define GTG_FLAG_PAJE_MULTIPLE_FILES 8

For writing events in separate files (one file per container)

## GTG_FLAG_USE_MPI

#define GTG_FLAG_USE_MPI 1

Several MPI processes are currently using GTG.

## Typedef Documentation

## gtg_flag_t

typedef uint8_t gtg_flag_t

Flags that can be specified to GTG.

## traceType_t

typedef enum traceType traceType_t

## Enumeration Type Documentation

## traceType

enum traceType

Enumerator
PAJE | Paje trace format.
VITE | ViTE-specific trace format.
OTF | OTF trace format.
TAU | TAU Trace format.

## Function Documentation

## AddComment()

trace_return_t AddComment | ( | const char * | comment | ) |

## addContainer()

trace_return_t addContainer | ( | varPrec | time,
|  | const char * | alias,
|  | const char * | type,
|  | const char * | container,
|  | const char * | name,
|  | const char * | file
| ) |  |

## addContType()

trace_return_t addContType | ( | const char * | alias,
|  | const char * | contType,
|  | const char * | name
| ) |  |

## addEntityValue()

trace_return_t addEntityValue | ( | const char * | alias,
|  | const char * | entType,
|  | const char * | name,
|  | gtg_color_t | p_color
| ) |  |

## addEvent()

trace_return_t addEvent | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | const char * | val
| ) |  |

## addEventType()

trace_return_t addEventType | ( | const char * | alias,
|  | const char * | contType,
|  | const char * | name
| ) |  |

## addLinkType()

trace_return_t addLinkType | ( | const char * | alias,
|  | const char * | name,
|  | const char * | contType,
|  | const char * | srcContType,
|  | const char * | destContType
| ) |  |

## addStateType()

trace_return_t addStateType | ( | const char * | alias,
|  | const char * | contType,
|  | const char * | name
| ) |  |

## addVar()

trace_return_t addVar | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | varPrec | val
| ) |  |

## addVarType()

trace_return_t addVarType | ( | const char * | alias,
|  | const char * | name,
|  | const char * | contType
| ) |  |

## bufferedModeActivated()

int bufferedModeActivated | ( |  | ) |

## destroyContainer()

trace_return_t destroyContainer | ( | varPrec | time,
|  | const char * | name,
|  | const char * | type
| ) |  |

## endLink()

trace_return_t endLink | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | const char * | src,
|  | const char * | dest,
|  | const char * | val,
|  | const char * | key
| ) |  |

## endTrace()

trace_return_t endTrace | ( |  | ) |

## getName()

char * getName | ( | int | procRk | ) |

## getTraceType()

traceType_t getTraceType | ( |  | ) |

## initTrace()

trace_return_t initTrace | ( | const char * | filename,
|  | int | rank,
|  | gtg_flag_t | flags
| ) |  |

## popState()

trace_return_t popState | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont
| ) |  |

## pushState()

trace_return_t pushState | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | const char * | val
| ) |  |

## setCompress()

trace_return_t setCompress | ( | int | val | ) |

## setState()

trace_return_t setState | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | const char * | val
| ) |  |

## setTraceType()

void setTraceType | ( | traceType_t | type | ) |

## setVar()

trace_return_t setVar | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | varPrec | val
| ) |  |

## startLink()

trace_return_t startLink | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | const char * | src,
|  | const char * | dest,
|  | const char * | val,
|  | const char * | key
| ) |  |

## subVar()

trace_return_t subVar | ( | varPrec | time,
|  | const char * | type,
|  | const char * | cont,
|  | varPrec | val
| ) |  |